////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "ButtonFM.cpp"
//             ( )
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "ButtonFM.h"
#include "../FastMines2.h"

extern CFastMines2WinMain& GetFM2WinMain();

void CButtonExFM::DrawBkgrnd(
#ifndef _WTL_VER
   HDC hCDC,
#else
   CDC &hCDC,
#endif
   const RECT& rect)
{
   if (GetFM2WinMain().GetSkin().m_bToAll) {
      HBRUSH hBrushNew = ::CreateSolidBrush(GetFM2WinMain().GetSkin().GetBkColor());
   #ifndef _WTL_VER
      HGDIOBJ hBrushOld = ::SelectObject(hCDC, hBrushNew);
      ::PatBlt(hCDC, rect.left,rect.top, rect.right-rect.left, rect.bottom-rect.top, PATCOPY);
      ::SelectObject(hCDC, hBrushOld);
   #else
      HBRUSH hBrushOld = hCDC.SelectBrush(hBrushNew);
      hCDC.PatBlt(rect.left,rect.top, rect.right-rect.left, rect.bottom-rect.top, PATCOPY);
      hCDC.SelectBrush(hBrushOld);
   #endif
      ::DeleteObject(hBrushNew);
   } else {
      CButtonEx::DrawBkgrnd(hCDC, rect);
   }
}

void CButtonImageFM::DrawBkgrnd(
#ifndef _WTL_VER
   HDC hCDC,
#else
   CDC &hCDC,
#endif
   const RECT& rect)
{
   if (GetFM2WinMain().GetSkin().m_bToAll) {
      HBRUSH hBrushNew = ::CreateSolidBrush(GetFM2WinMain().GetSkin().GetBkColor());
   #ifndef _WTL_VER
      HGDIOBJ hBrushOld = ::SelectObject(hCDC, hBrushNew);
      ::PatBlt(hCDC, rect.left,rect.top, rect.right-rect.left, rect.bottom-rect.top, PATCOPY);
      ::SelectObject(hCDC, hBrushOld);
   #else
      HBRUSH hBrushOld = hCDC.SelectBrush(hBrushNew);
      hCDC.PatBlt(rect.left,rect.top, rect.right-rect.left, rect.bottom-rect.top, PATCOPY);
      hCDC.SelectBrush(hBrushOld);
   #endif
      ::DeleteObject(hBrushNew);
   } else {
      CButtonImage::DrawBkgrnd(hCDC, rect);
   }
}
