////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "ButtonImage.h"
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__BUTTONIMAGE__
#define __FILE__BUTTONIMAGE__

#include "ButtonEx.h"
#include "../Image.h"

#ifndef _WTL_VER

class CButtonImage: public CButtonEx {
public:
   enum {
      _nImageNormal = 0,
      _nImagePushed,
      _nImageMouseOver,
      _nImageDisabled,

      _nImageCount = 4,
   };
protected:
   CImage m_Img[_nImageCount];
public:
   CButtonImage(HWND hWndBttn = NULL);
   CImageSerialize GetImage(WORD nImage) const;
   BOOL SetImage(const CImageSerialize &img, WORD nImage);
   BOOL ImageSetted() const;

protected:
   virtual BOOL DrawCustom(HDC, const RECT&);
};

////////////////////////////////////////////////////////////////////////////////////////////////////////
#else // _WTL_VER
////////////////////////////////////////////////////////////////////////////////////////////////////////

#if (_WIN32_WINNT >= 0x0501)
   //#include <AtlTheme.h> //    ,     CTheme, ..  CTheme     XP.
#endif

template <class T, class TBase = CButton, class TWinTraits = CControlWinTraits>
class ATL_NO_VTABLE CButtonImageImpl : public CButtonExImpl< T, TBase, TWinTraits> {
public:
   DECLARE_WND_SUPERCLASS(NULL, TBase::GetWndClassName())

   enum {
      _nImageNormal = 0,
      _nImagePushed,
      _nImageMouseOver,
      _nImageDisabled,

      _nImageCount = 4,
   };

protected:
   CImage m_Img[_nImageCount];
public:
   // Constructor/Destructor
   CButtonImageImpl(HWND hWnd = NULL) {}
  ~CButtonImageImpl() {}

   // Attributes
   CImageSerialize GetImage(WORD nImage) const;
   BOOL SetImage(const CImageSerialize &img, WORD nImage);
   BOOL ImageSetted() const;

protected:
   virtual BOOL DrawCustom(CDC&, const RECT&);
};

class CButtonImage : public CButtonImageImpl<CButtonImage> {
public:
   DECLARE_WND_SUPERCLASS(_T("WTL_ButtonImage_from_KSerg"), GetWndClassName())
   CButtonImage(HWND hWnd = NULL) : CButtonImageImpl<CButtonImage>(hWnd) { m_bDrawingFocus = FALSE; }
};

#include "ButtonImage.hpp"

#endif // _WTL_VER

#endif // __FILE__BUTTONIMAGE__
