////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "EditEx.hpp"
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifdef _WTL_VER

template <class T, class TBase, class TWinTraits>
void CEditExImpl<T, TBase, TWinTraits>::DoPaint(CDCHandle hDC) {
   RECTEX rc = ::GetClientRect(m_hWnd);
   CDC hCDC1; hCDC1.CreateCompatibleDC(hDC);
   CDC hCDC2; hCDC2.CreateCompatibleDC(hDC);
   CBitmap hBmpNew1; hBmpNew1.CreateCompatibleBitmap(hDC, rc.width(), rc.height());
   CBitmap hBmpNew2; hBmpNew2.CreateCompatibleBitmap(hDC, rc.width(), rc.height());
   HBITMAP hBmpOld1 = hCDC1.SelectBitmap(hBmpNew1);
   HBITMAP hBmpOld2 = hCDC2.SelectBitmap(hBmpNew2);

   //  
   /**/
   //     (  , ..       :( )
   if (!DrawBkgrnd(hCDC1, rc)) {
      CBrush hBrushNew; hBrushNew.CreateSolidBrush(GetBkColor());
      HBRUSH hBrushOld = hCDC1.SelectBrush(hBrushNew);

      hCDC1.PatBlt(0,0,rc.width(),rc.height(), PATCOPY);

      hCDC1.SelectBrush(hBrushOld);

   }/**/
   DefWindowProc(WM_PAINT, (WPARAM)(HDC)hCDC1, 0);

   //  
   if (!DrawBkgrnd(hCDC2, rc)) {
      CBrush hBrushNew; hBrushNew.CreateSolidBrush(GetBkColor());
      HBRUSH hBrushOld = hCDC2.SelectBrush(hBrushNew);

      hCDC2.PatBlt(0,0,rc.width(),rc.height(), PATCOPY);

      hCDC2.SelectBrush(hBrushOld);

   }

   //  
   //hCDC2.TransparentBlt(0,0, rc.width(), rc.height(), hCDC1, 0,0, rc.width(), rc.height(), GetBkColorOriginal());
   ::BitBltMasked(hCDC2, RECTEX(rc.size()), hCDC1, POINTEX(), GetBkColorOriginal());
   ::BitBlt(hDC, rc, hCDC2, SRCCOPY);

   hCDC1.SelectBitmap(hBmpOld1);
   hCDC2.SelectBitmap(hBmpOld2);
}

template <class T, class TBase, class TWinTraits>
LRESULT CEditExImpl<T, TBase, TWinTraits>::OnPaint(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
   //T* pT = static_cast<T*>(this);
   if (wParam) {
      /*pT->*/DoPaint((HDC)wParam);
   } else {
      /*pT->*/DoPaint(CPaintDC(m_hWnd).m_hDC);
   }
   return 0;
}

template <class T, class TBase, class TWinTraits>
LRESULT CEditExImpl<T, TBase, TWinTraits>::OnDrawAgain(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
   LRESULT lResult = DefWindowProc(uMsg, wParam, lParam);
   InvalidateRect(NULL, FALSE);
   UpdateWindow();
   return lResult;
}

#endif // _WTL_VER
