////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "EditGradient.h"
// Copyright (C) 2006-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__EDIT_GRADIENT__
#define __FILE__EDIT_GRADIENT__

#include "EditEx.h"

class CEditGradient: public CEditEx {
protected:
   #ifndef _WTL_VER
      virtual BOOL DrawBkgrnd(HDC, const RECT&);
   #else // _WTL_VER
      virtual BOOL DrawBkgrnd(CDC&, const RECT&);
   #endif // _WTL_VER

   virtual COLORREF GetBkColorDisable2 () const;// { return ::GetSysColor(COLOR_BTNFACE); }
   virtual COLORREF GetBkColorReadOnly2() const;// { return ::GetSysColor(COLOR_BTNFACE); }
   virtual COLORREF GetBkColorEnable2  () const;// { return ::GetSysColor(COLOR_WINDOW ); }

   COLORREF GetBkColor2() {
      bool bDisable = !::IsWindowEnabled(m_hWnd);
      bool bReadOnly = !!(::GetWindowStyle(m_hWnd) & ES_READONLY);
      return bDisable  ? GetBkColorDisable2() :
             bReadOnly ? GetBkColorReadOnly2() :
                         GetBkColorEnable2();
   }
};

#endif // __FILE__EDIT_GRADIENT__
