////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "About.cpp"
//    "About"
// Copyright (C) 2002-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////
//
// 2007.03.02
//        ...
//
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "About.h"
#include "../FastMines2.h"
#include "../EraseBk.h"
#include "../Lang.h"
#include "./DialogMessageHook.h"
#include <ShellAPI.h>

////////////////////////////////////////////////////////////////////////////////
//                      global variables, types , defines, etc...
////////////////////////////////////////////////////////////////////////////////
extern CFastMines2WinMain& GetFM2WinMain();

WNDPROC_STATIC(IDC_ABOUT_PRODUCTNAME, GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_VERSION    , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_COPYRIGHT  , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_COMMENTS   , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_RESPONSE   , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_ICQ        , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_FIDO       , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_FIDOADDRESS, GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_FMSITE     , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_UKRPOST    , GetFM2WinMain().GetSkin())
WNDPROC_STATIC(IDC_ABOUT_SITE       , GetFM2WinMain().GetSkin())

////////////////////////////////////////////////////////////////////////////////
//                          implementation
////////////////////////////////////////////////////////////////////////////////

#ifndef _WTL_VER

HWND CDialogAbout::Create(HWND hWndParent) {
   return ::CreateDialogParam(::GetModuleHandle(NULL), CDialogAbout::IDD(), hWndParent, (DLGPROC)CDialogAbout::DialogProcThis, (LPARAM)this);
}

/*static*/ INT_PTR CALLBACK CDialogAbout::DialogProcThis(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
   //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  CDialogAbout::DialogProcThis: %s "), (LPCTSTR)CLogger::WindowMessage(uMsg));
   CDialogAbout *This = NULL;
   if (uMsg == WM_INITDIALOG) {
      This = (CDialogAbout*)lParam;
      if (This) {
         This->m_hWnd = hWnd;
         ::SetWindowUserData(hWnd, (LONG_PTR)This);
      }
   } else {
      This = (CDialogAbout*)::GetWindowUserData(hWnd);
   }
   if (This) {
      return This->DialogProc(hWnd, uMsg, wParam, lParam);
   }
   return FALSE;
}

BOOL CDialogAbout::OnInitDialog(HWND, HWND hwndFocus, LPARAM lParam) {
   m_BtnOk        .SubclassWindow(::GetDlgItem(m_hWnd, IDOK));
   m_BtnLogo      .SubclassWindow(::GetDlgItem(m_hWnd, IDC_ABOUT_ICON_PROJ));
   m_EditICQAdress.SubclassWindow(::GetDlgItem(m_hWnd, IDC_ABOUT_ICQADDRESS));

   HWND hWnd = ::GetParent(m_hWnd);
   m_BtnLogo.SetImage(CImageSerialize(_T("?14#iconPROJECT"), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle), CButtonImage::_nImageNormal);
   m_BtnLogo.SetImage(/*!gpFM2Proj ? CImageSerialize(_T("?ICO#New3")) : */GetFM2WinMain().GetImageBtnNew(3), CButtonImage::_nImagePushed);

   ::SetWindowText(m_hWnd                                   , CLang::GetString(IDS__DIALOG_ABOUT));
   ::SetWindowText(m_BtnOk.m_hWnd                           , CLang::GetString(IDS__OK    ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDCANCEL)           , CLang::GetString(IDS__CANCEL));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ABOUT_VERSION  ), CLang::GetString(IDS__DIALOG_ABOUT__VERSION  )+ _T(" ") + ::GetFileVersion(::GetModuleFileName()) + _T(" (C++, WinAPI)"));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ABOUT_COPYRIGHT), CLang::GetString(IDS__DIALOG_ABOUT__COPYRIGHT)+ _T("   - Sergey Krivulya (KSerg)"));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ABOUT_COMMENTS ), CLang::GetString(IDS__DIALOG_ABOUT__COMMEMTS ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ABOUT_RESPONSE ), CLang::GetString(IDS__DIALOG_ABOUT__RESPONSE ));
   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_ABOUT_FMSITE   ), CLang::GetString(IDS__DIALOG_ABOUT__SITE     ));
 //::SetWindowText(::GetDlgItem(m_hWnd, IDC_ABOUT_SITE     ), CLang::GetString(IDS__WEB_PAGE__FASTMINES    ));


   HWND hWndPN = ::GetDlgItem(m_hWnd, IDC_ABOUT_PRODUCTNAME);
   ::SetWindowText(hWndPN, CLang::GetString(IDS__LOGO));
   LOGFONT font;
	if (sizeof(LOGFONT) == ::GetObject((HFONT)::SendMessage(hWndPN, WM_GETFONT, 0, 0), sizeof(LOGFONT), &font)) {
      lstrcpyn(font.lfFaceName, _T("Times New Roman"), LF_FACESIZE);
      font.lfHeight -= 15;
      font.lfWeight = FW_BOLD;
      HFONT hFontNew = ::CreateFontIndirect(&font);
      ::SendMessage(hWndPN, WM_SETFONT, (WPARAM)hFontNew, MAKELPARAM(FALSE, 0));
   }

   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_PRODUCTNAME);
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_VERSION    );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_COPYRIGHT  );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_COMMENTS   );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_RESPONSE   );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_ICQ        );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_FMSITE     );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_UKRPOST    );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_SITE       );

   CDialogMessageHook::InstallHook(m_hWnd);

   return TRUE;
}

void CDialogAbout::OnCommand(HWND, int idControl, HWND hwndCtl, UINT codeNotify) {
   switch (idControl) {
   case IDC_ABOUT_ICON_MAIL:
   case IDC_ABOUT_UKRPOST:
      if (codeNotify == STN_CLICKED)
         ::ShellExecute(m_hWnd, _T("open"), _T("mailto:Sergey_Krivulya@UkrPost.net?subject=FastMines"), NULL, NULL, SW_RESTORE);
      return;
   case IDC_ABOUT_SITE:
      if (codeNotify == STN_CLICKED)
         ::ShellExecute(m_hWnd, _T("open"), CLang::GetString(IDS__WEB_PAGE__FASTMINES)/*_T("http://kserg77.narod.ru")*/, NULL, NULL, SW_RESTORE);
      return;
   case IDC_ABOUT_COMMENTS:
      if (codeNotify == STN_CLICKED)
         ::ShellExecute(m_hWnd, _T("open"), ::GetModuleDir(::GetModuleHandle(NULL))+ _T("license.rtf"), NULL, NULL, SW_RESTORE);
      return;
   case IDCANCEL:
   case IDOK:
      if (codeNotify == BN_CLICKED) {
         ::SendMessage(m_hWnd, WM_CLOSE, 0L, 0L);
      }
      return;
   }
}

void CDialogAbout::OnClose(HWND) {
   ::DestroyWindow(m_hWnd);
}

void CDialogAbout::OnDestroy(HWND) {
   CDialogMessageHook::UninstallHook(m_hWnd);
   m_hWnd = NULL;
}

BOOL CDialogAbout::OnEraseBkgnd(HWND, HDC hDC) {
   if (!GetFM2WinMain().GetSkin().m_bToAll)
   {
      return FALSE; // DefWindowProc(m_hWnd, WM_ERASEBKGND, (WPARAM)hdc, 0L);
   }
   return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, GetFM2WinMain().GetSkin().GetBkColor());
}

////////////////////////////////////////////////////////////////////////////////////////////////////////
#else // _WTL_VER
////////////////////////////////////////////////////////////////////////////////////////////////////////

// modeless dialogs
HWND CDialogAbout::Create(HWND hWndParent, LPARAM dwInitParam)
{
	ATLASSERT(m_hWnd == NULL);
	_Module.AddCreateWndData(&m_thunk.cd, this);
#ifdef _DEBUG
	m_bModal = false;
#endif //_DEBUG
	HWND hWnd = ::CreateDialogParam(_Module.GetResourceInstance(), CDialogAbout::IDD(), hWndParent, (DLGPROC)CDialogAbout::StartDialogProc, dwInitParam);
	ATLASSERT(m_hWnd == hWnd);
	return hWnd;
}

BOOL CDialogAbout::OnInitDialog(HWND hwndFocus, LPARAM lParam) {
   DoDataExchange();
   m_HyperLink_UkrPost.SetHyperLink(_T("mailto:Sergey_Krivulya@UkrPost.net?subject=FastMines"));
   m_HyperLink_Site   .SetHyperLink(CLang::GetString(IDS__WEB_PAGE__FASTMINES)/*_T("http://kserg77.narod.ru")*/);
   m_BtnLogo.SetImage(CImageSerialize(_T("?14#iconPROJECT")), CButtonImage::_nImageNormal);
   m_BtnLogo.SetImage(/*!gpFM2Proj ? CImageSerialize(_T("?ICO#New3")) : */GetFM2WinMain().GetImageBtnNew(3), CButtonImage::_nImagePushed);

   SetWindowText(                                   CLang::GetString(IDS__DIALOG_ABOUT));
   m_BtnOk.SetWindowText(                           CLang::GetString(IDS__OK));
   ::SetWindowText(GetDlgItem(IDCANCEL),            CLang::GetString(IDS__CANCEL));
   ::SetWindowText(GetDlgItem(IDC_ABOUT_VERSION  ), CLang::GetString(IDS__DIALOG_ABOUT__VERSION  )+ _T(" ") + ::GetFileVersion(::GetModuleFileName()) + _T(" (C++, WTL)"));
   ::SetWindowText(GetDlgItem(IDC_ABOUT_COPYRIGHT), CLang::GetString(IDS__DIALOG_ABOUT__COPYRIGHT)+ _T("   - Sergey Krivulya (KSerg)"));
 //::SetWindowText(GetDlgItem(IDC_ABOUT_COMMENTS ), CLang::GetString(IDS__DIALOG_ABOUT__COMMEMTS ));
   m_HyperLink_License.SetLabel(CLang::GetString(IDS__DIALOG_ABOUT__COMMEMTS ));
   ::SetWindowText(GetDlgItem(IDC_ABOUT_RESPONSE ), CLang::GetString(IDS__DIALOG_ABOUT__RESPONSE ));
   ::SetWindowText(GetDlgItem(IDC_ABOUT_FMSITE   ), CLang::GetString(IDS__DIALOG_ABOUT__SITE     ));

   CString strFileLicense = ::GetModuleDir(::GetModuleHandle(NULL))+ _T("license.rtf");
   if (::FileExist(strFileLicense)) {
      m_HyperLink_License.SetHyperLink(strFileLicense);
   } else  {
      m_HyperLink_License.EnableWindow(FALSE);
   }

   CWindow wndPN = GetDlgItem(IDC_ABOUT_PRODUCTNAME);
   wndPN.SetWindowText(CLang::GetString(IDS__LOGO));
   LOGFONT font;
   if (sizeof(LOGFONT) == ::GetObject(wndPN.GetFont(), sizeof(LOGFONT), &font)) {
      lstrcpyn(font.lfFaceName, _T("Times New Roman"), LF_FACESIZE);
      font.lfHeight -= 15;
      font.lfWeight = FW_BOLD;
      HFONT hFontNew = ::CreateFontIndirect(&font);
      wndPN.SetFont(hFontNew, FALSE);
   }

   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_PRODUCTNAME);
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_VERSION    );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_COPYRIGHT  );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_COMMENTS   );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_RESPONSE   );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_ICQ        );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_FMSITE     );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_UKRPOST    );
   SETNEWWNDPROC(m_hWnd, IDC_ABOUT_SITE       );

   CDialogMessageHook::InstallHook(m_hWnd);

   return TRUE;
}

void CDialogAbout::OnCommand(UINT codeNotify, int idControl, HWND /*hwndCtl*/) {
   switch (idControl) {
   case IDCANCEL:
   case IDOK:
      if (codeNotify == BN_CLICKED) {
         SendMessage(WM_CLOSE, 0L, 0L);
      }
      return;
   }
}

void CDialogAbout::OnClose() {
   DestroyWindow();
}

void CDialogAbout::OnDestroy() {
   CDialogMessageHook::UninstallHook(m_hWnd);

}

BOOL CDialogAbout::OnEraseBkgnd(HDC hDC) {
   if (!GetFM2WinMain().GetSkin().m_bToAll) {
      SetMsgHandled(FALSE);
      return FALSE; // DefWindowProc(m_hWnd, WM_ERASEBKGND, (WPARAM)hdc, 0L);
   }
   return nsEraseBk::OnEraseBkgnd(m_hWnd, hDC, GetFM2WinMain().GetSkin().GetBkColor());
}

#endif // _WTL_VER
