// DialogMessageHook.h: interface for the CDialogMessageHook class.
//
// http://www.codeproject.com/atl/cdialogmessagehook.asp
// Tabs and Accelerators in ATL Modeless Dialogs
//  By Anatoly Ivasyuk 
// A generic class that enables standard tab and accelerator processing in modeless ATL dialogs. 
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIALOGMESSAGEHOOK_H__53812B4C_FBAD_4FD3_8238_85CD48CFE453__INCLUDED_)
#define AFX_DIALOGMESSAGEHOOK_H__53812B4C_FBAD_4FD3_8238_85CD48CFE453__INCLUDED_

#include <Windows.h>
#include <set>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// CDialogMessageHook makes it easy to properly process tab and accelerator keys in
// ATL modeless dialogs
class CDialogMessageHook  
{
   typedef std::set<HWND> THWNDCollection;
public:
   // set a dialog message hook for the specified modeless dialog
   static HRESULT InstallHook(HWND hWnd);
   static HRESULT UninstallHook(HWND hWnd);

private:
   // the hook function
   static LRESULT CALLBACK GetMessageProc(int nCode, WPARAM wParam, LPARAM lParam);

   // the hook handle
   static HHOOK& m_hHook() { static HHOOK hHook = NULL; return hHook; }

   // the set of HWNDs we are hooking
   static THWNDCollection& m_aWindows() { static THWNDCollection aWindows; return aWindows; }
};

#endif // !defined(AFX_DIALOGMESSAGEHOOK_H__53812B4C_FBAD_4FD3_8238_85CD48CFE453__INCLUDED_)