////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "FastMines2.h"
//
//
// Copyright (C) 2002-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////
//
// 2007.02.27 - 2007.03.02
//        -    
//
////////////////////////////////////////////////////////////////////////////////

#ifndef __FILE__FASTMINES2__
#define __FILE__FASTMINES2__

#include "./Dialog/ToolbarFM.h"
#include "./Mosaic.h"
#include "./Players.h"
#include <list>
#include "./ODItems/MenuItem.h"

////////////////////////////////////////////////////////////////////////////////
//                            types & constants
////////////////////////////////////////////////////////////////////////////////

struct CSkin: public CSkinMosaic, public IFileBody {
   CImageSerialize m_ImgBtnNew  [4],
                   m_ImgBtnPause[4];
   BOOL            m_bToAll; //   m_colorBk   ?
   CSkin(): m_bToAll(false) {
      m_ImgMine        = CImageSerialize(_T("?2#Mine"    ), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Mine.bmp"  )//
      m_ImgFlag        = CImageSerialize(_T("?2#Flag"    ), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Flag.bmp"  )//
      m_ImgsPause.AddImg(CImageSerialize(_T("?EMF#Pause" ), TRUE, CLR_INVALID, CImg::ePlaceUniformly | CImg::ePlaceCenter | CImg::ePlaceMiddle));//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Face.emf"  )//
      m_ImgBckgrnd     = CImageSerialize();                                                                                                      //);//);                                                                   //
      m_ImgBtnNew  [0] = CImageSerialize(_T("?ICO#New0"  ), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\New0.ico"  )//
      m_ImgBtnNew  [1] = CImageSerialize(_T("?ICO#New1"  ), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\New1.ico"  )//
      m_ImgBtnNew  [2] = CImageSerialize(_T("?ICO#New2"  ), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\New2.ico"  )//
      m_ImgBtnNew  [3] = CImageSerialize(_T("?ICO#New3"  ), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\New3.ico"  )//
      m_ImgBtnPause[0] = CImageSerialize(_T("?ICO#Pause0"), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Pause0.ico")//
      m_ImgBtnPause[1] = CImageSerialize(_T("?ICO#Pause1"), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Pause1.ico")//
      m_ImgBtnPause[2] = CImageSerialize(_T("?ICO#Pause2"), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Pause2.ico")//
      m_ImgBtnPause[3] = CImageSerialize(_T("?ICO#Pause3"), TRUE, CLR_INVALID, CImg::ePlaceStretch   | CImg::ePlaceCenter | CImg::ePlaceMiddle) ;//);//_T("c:\\Project\\CPP\\_FastMines_\\FastMines2\\Resource\\Pause3.ico")//
   }
   const CSkin& operator=(const CSkin& skin) {
      *((CSkinMosaic*)this) = (CSkinMosaic)skin;
      m_ImgMine        = CImage(skin.m_ImgMine       ).Valid() ? skin.m_ImgMine        : CSkin().m_ImgMine       ;
      m_ImgFlag        = CImage(skin.m_ImgFlag       ).Valid() ? skin.m_ImgFlag        : CSkin().m_ImgFlag       ;
      m_ImgBckgrnd     = CImage(skin.m_ImgBckgrnd    ).Valid() ? skin.m_ImgBckgrnd     : CSkin().m_ImgBckgrnd    ;
      m_ImgBtnNew  [0] = CImage(skin.m_ImgBtnNew  [0]).Valid() ? skin.m_ImgBtnNew  [0] : CSkin().m_ImgBtnNew  [0];
      m_ImgBtnNew  [1] = CImage(skin.m_ImgBtnNew  [1]).Valid() ? skin.m_ImgBtnNew  [1] : CSkin().m_ImgBtnNew  [1];
      m_ImgBtnNew  [2] = CImage(skin.m_ImgBtnNew  [2]).Valid() ? skin.m_ImgBtnNew  [2] : CSkin().m_ImgBtnNew  [2];
      m_ImgBtnNew  [3] = CImage(skin.m_ImgBtnNew  [3]).Valid() ? skin.m_ImgBtnNew  [3] : CSkin().m_ImgBtnNew  [3];
      m_ImgBtnPause[0] = CImage(skin.m_ImgBtnPause[0]).Valid() ? skin.m_ImgBtnPause[0] : CSkin().m_ImgBtnPause[0];
      m_ImgBtnPause[1] = CImage(skin.m_ImgBtnPause[1]).Valid() ? skin.m_ImgBtnPause[1] : CSkin().m_ImgBtnPause[1];
      m_ImgBtnPause[2] = CImage(skin.m_ImgBtnPause[2]).Valid() ? skin.m_ImgBtnPause[2] : CSkin().m_ImgBtnPause[2];
      m_ImgBtnPause[3] = CImage(skin.m_ImgBtnPause[3]).Valid() ? skin.m_ImgBtnPause[3] : CSkin().m_ImgBtnPause[3];
      m_bToAll = skin.m_bToAll;
      
      m_ImgsPause.Clear();
      m_ImgsPause.AddImg((skin.m_ImgsPause.GetSize() && CImage(skin.m_ImgsPause.GetImg(0)).Valid()) ? skin.m_ImgsPause.GetImg(0) : CSkin().m_ImgsPause.GetImg(0));
      for (UINT i=1; i<skin.m_ImgsPause.GetSize(); i++) {
         if (CImage(skin.m_ImgsPause.GetImg(i)).Valid())
            m_ImgsPause.AddImg(skin.m_ImgsPause.GetImg(i));
      }

      return *this;
   }
   BOOL SerializeRead(HANDLE hFile) {
      DWORD dwNOBR = 0;
      BOOL bRes = CSkinMosaic::SerializeRead(hFile) &&
                  m_ImgBtnNew  [0].SerializeRead(hFile) &&
                  m_ImgBtnNew  [1].SerializeRead(hFile) &&
                  m_ImgBtnNew  [2].SerializeRead(hFile) &&
                  m_ImgBtnNew  [3].SerializeRead(hFile) &&
                  m_ImgBtnPause[0].SerializeRead(hFile) &&
                  m_ImgBtnPause[1].SerializeRead(hFile) &&
                  m_ImgBtnPause[2].SerializeRead(hFile) &&
                  m_ImgBtnPause[3].SerializeRead(hFile) &&
                  (::ReadFile(hFile, &m_bToAll, sizeof(BOOL), &dwNOBR, NULL) && (sizeof(BOOL) == dwNOBR));
      if (!bRes) *this = CSkin();
      return bRes;
   }
   BOOL SerializeWrite(HANDLE hFile) const {
      DWORD dwNOBW = 0;
      BOOL bRes = CSkinMosaic::SerializeWrite(hFile) &&
                  m_ImgBtnNew  [0].SerializeWrite(hFile) &&
                  m_ImgBtnNew  [1].SerializeWrite(hFile) &&
                  m_ImgBtnNew  [2].SerializeWrite(hFile) &&
                  m_ImgBtnNew  [3].SerializeWrite(hFile) &&
                  m_ImgBtnPause[0].SerializeWrite(hFile) &&
                  m_ImgBtnPause[1].SerializeWrite(hFile) &&
                  m_ImgBtnPause[2].SerializeWrite(hFile) &&
                  m_ImgBtnPause[3].SerializeWrite(hFile) &&
                  (::WriteFile(hFile, &m_bToAll, sizeof(BOOL), &dwNOBW, NULL) && (sizeof(BOOL) == dwNOBW));
      return bRes;
   }
};

struct CSerializeProj : public IFileBody {
   CMosaic       m_Mosaic;
   CSkin         m_Skin;
   CString       m_strPlayerName; //  
   BOOL          m_bAlwaysMaxSize;
   BOOL          m_bToTray;
   BOOL          m_bShowToolbar;
   BOOL          m_bShowMenu;
   BOOL          m_bShowCaption;
   BOOL          m_bAutoloadAdmin;
   POINTEX       m_PointCenter;
   CString       m_strLanguage; //  
   CSerializeProj():
      m_strPlayerName (_T("Anonymous")),
      m_bAlwaysMaxSize(FALSE),
      m_bToTray       (FALSE),
      m_bShowToolbar  (TRUE),
      m_bShowMenu     (TRUE),
      m_bShowCaption  (TRUE),
      m_bAutoloadAdmin(TRUE),
      m_PointCenter   (::GetScreenSize()/2) {}
   BOOL SerializeRead(HANDLE hFile) {
      DWORD dwNOBR = 0;
      BOOL bRes = m_Mosaic.SerializeRead(hFile) &&
                  m_Skin.SerializeRead(hFile) &&
                  ::SerializeRead(hFile, m_strPlayerName) &&
                  (::ReadFile(hFile, &m_bAlwaysMaxSize, sizeof(m_bAlwaysMaxSize), &dwNOBR, NULL) && (sizeof(m_bAlwaysMaxSize) == dwNOBR)) &&
                  (::ReadFile(hFile, &m_bToTray       , sizeof(m_bToTray       ), &dwNOBR, NULL) && (sizeof(m_bToTray       ) == dwNOBR)) &&
                  (::ReadFile(hFile, &m_bShowToolbar  , sizeof(m_bShowToolbar  ), &dwNOBR, NULL) && (sizeof(m_bShowToolbar  ) == dwNOBR)) &&
                  (::ReadFile(hFile, &m_bShowMenu     , sizeof(m_bShowMenu     ), &dwNOBR, NULL) && (sizeof(m_bShowMenu     ) == dwNOBR)) &&
                  (::ReadFile(hFile, &m_bShowCaption  , sizeof(m_bShowCaption  ), &dwNOBR, NULL) && (sizeof(m_bShowCaption  ) == dwNOBR)) &&
                  (::ReadFile(hFile, &m_bAutoloadAdmin, sizeof(m_bAutoloadAdmin), &dwNOBR, NULL) && (sizeof(m_bAutoloadAdmin) == dwNOBR)) &&
                  (::ReadFile(hFile, &m_PointCenter   , sizeof(m_PointCenter   ), &dwNOBR, NULL) && (sizeof(m_PointCenter   ) == dwNOBR)) &&
                  ::SerializeRead(hFile, m_strLanguage);
      if (!bRes) {
         *this = CSerializeProj();
      }
      return bRes;
   }

   BOOL CSerializeProj::SerializeWrite(HANDLE hFile) const {
      DWORD dwNOBW = 0;
      BOOL bRes = m_Mosaic.SerializeWrite(hFile) &&
                  m_Skin.SerializeWrite(hFile) &&
                  ::SerializeWrite(hFile, m_strPlayerName) &&
                  (::WriteFile(hFile, &m_bAlwaysMaxSize, sizeof(m_bAlwaysMaxSize), &dwNOBW, NULL) && (sizeof(m_bAlwaysMaxSize) == dwNOBW)) &&
                  (::WriteFile(hFile, &m_bToTray       , sizeof(m_bToTray       ), &dwNOBW, NULL) && (sizeof(m_bToTray       ) == dwNOBW)) &&
                  (::WriteFile(hFile, &m_bShowToolbar  , sizeof(m_bShowToolbar  ), &dwNOBW, NULL) && (sizeof(m_bShowToolbar  ) == dwNOBW)) &&
                  (::WriteFile(hFile, &m_bShowMenu     , sizeof(m_bShowMenu     ), &dwNOBW, NULL) && (sizeof(m_bShowMenu     ) == dwNOBW)) &&
                  (::WriteFile(hFile, &m_bShowCaption  , sizeof(m_bShowCaption  ), &dwNOBW, NULL) && (sizeof(m_bShowCaption  ) == dwNOBW)) &&
                  (::WriteFile(hFile, &m_bAutoloadAdmin, sizeof(m_bAutoloadAdmin), &dwNOBW, NULL) && (sizeof(m_bAutoloadAdmin) == dwNOBW)) &&
                  (::WriteFile(hFile, &m_PointCenter   , sizeof(m_PointCenter   ), &dwNOBW, NULL) && (sizeof(m_PointCenter   ) == dwNOBW)) &&
                  ::SerializeWrite(hFile, m_strLanguage);
      return bRes;
   }
};

class CFastMines2WinMain : public CCommonSerializeEx<IFileHeaderImpl<0x702CEC99/*0x5B49B5AE*/>, CSerializeProj,
                                                     IDS__INI_FILE__ERROR_CREATE,
                                                     IDS__INI_FILE__ERROR_OPEN,
                                                     IDS__INI_FILE__ERROR_READ,
                                                     IDS__INI_FILE__ERROR_WRITE,
                                                     IDS__INI_FILE__ERROR_VERSION>
{
private:
   typedef std::list<CMenuItem*> LIST_MenuItem; //    
public:
   HWND    m_hWnd;
private:
   HMENU   m_hMenu;
   HICON   m_hIconProject;
   CToolbarFM m_Toolbar;

   LIST_MenuItem m_MenuItems;

   CPlayers m_Players;

private:
   static LPCTSTR GetWindowClass() {
      const static TCHAR szWndClass[] = _T("ClassWndFastMinesProject");
      return szWndClass;
   }

   static LRESULT CALLBACK WndProcThis(HWND, UINT, WPARAM, LPARAM);
   LRESULT WndProc(HWND, UINT, WPARAM, LPARAM);

   CString GetFileName() const { return _T("Mines.dat"); }
   BOOL Convert(HANDLE hFile) { return FALSE; }
   BOOL IgnoreFileNotFound() const { return TRUE; }

   void TrayMessage(UINT, const TCHAR*);

   BOOL OnCreate           (HWND, LPCREATESTRUCT);           // WM_CREATE
   void OnDestroy          (HWND);                           // WM_DESTROY
   void OnActivate         (HWND, UINT, HWND, BOOL);         // WM_ACTIVATE
   void OnMove             (HWND, int, int);                 // WM_MOVE
   void OnSize             (HWND, UINT, int,  int);          // WM_SIZE
   void OnSysCommand       (HWND, UINT, int,  int);          // WM_SYSCOMMAND (SC_MAXIMIZE)
   void OnCommand          (HWND, int , HWND, UINT);         // WM_COMMAND
   void OnGetMinMaxInfo    (HWND, LPMINMAXINFO);             // WM_GETMINMAXINFO
   BOOL OnWindowPosChanging(HWND, LPWINDOWPOS);              // WM_WINDOWPOSCHANGING
   void OnWindowPosChanged (HWND, const LPWINDOWPOS);        // WM_WINDOWPOSCHANGED
   void OnMeasureItem      (HWND, MEASUREITEMSTRUCT*);       // WM_MEASUREITEM
   void OnDrawItem         (HWND, const DRAWITEMSTRUCT*);    // WM_DRAWITEM
   void OnNotifyIcon       (HWND, UINT);                     // WM_NOTIFYICON
   BOOL OnEraseBkgnd       (HWND, HDC);                      // WM_ERASEBKGND
   void OnMosaicAdjustArea      (HWND);                      // WM_MOSAIC_ADJUSTAREA
   void OnMosaicClick           (HWND, BOOL, BOOL);          // WM_MOSAIC_CLICK
   void OnMosaicChangeCounters  (HWND);                      // WM_MOSAIC_CHANGECOUNTERS
   void OnMosaicChangeGameStatus(HWND, EGameStatus);         // WM_MOSAIC_CHANGEGAMESTATUS
   void OnMosaicPause           (HWND);                      // WM_MOSAIC_PAUSE
   void OnMouseWheel            (HWND, int, int, int, WORD); // WM_MOUSEWHEEL

   void OnSelectPlayer(HWND, BOOL);                          // WM_SELECT_PLAYER

   //void ResetAssistant();

   int GetMaximalArea() const;
   bool AreaIncrement();
   bool AreaDecrement();
   bool AreaMax();
   bool AreaMin();
   void CheckMenuRadioItem_Mosaic(EMosaic) const;

   void Apply_AlwaysMaxSize();
   void Apply_ToTray();
   void Apply_ShowToolbar();
   void Apply_ShowMenu();
   void Apply_ShowCaption();
   void Apply_UseAssistant();
   void Apply_UseUnknown();
   void ApplySkin();

public:
   void SetOwnerDrawMenu(HMENU);
private:
   void ReloadOwnerDrawMenu();
   void DelOwnerDrawMenu();

   void GameLoad(LPCTSTR szFileName = NULL);
   void GameSave();

   static BOOL CALLBACK CloseDialogs(HWND, LPARAM);
   static BOOL CALLBACK InvalidateDialogs(HWND, LPARAM);

public:
   CFastMines2WinMain();
  ~CFastMines2WinMain();
   void Create(LPCTSTR szFileName = NULL);

   void                  SetAssistantInfo(  const CAssistantInfo &newAssistantInfo) {m_Body.m_Mosaic.SetAssistantInfo(newAssistantInfo);}
   const CAssistantInfo& GetAssistantInfo() const {return m_Body.m_Mosaic.GetAssistantInfo();}
   const CSkin&          GetSkin         () const {return m_Body.m_Skin;}
   void                  SetSkin         (  const CSkin &newSkin) {m_Body.m_Skin = newSkin; ApplySkin();}
   BOOL                  GetAutoloadAdmin() const {return m_Body.m_bAutoloadAdmin;}
   void                  SetAutoloadAdmin(BOOL bAutoloadAdmin) { m_Body.m_bAutoloadAdmin = bAutoloadAdmin;}
   LPCTSTR               GetPlayerName   () const {return m_Body.m_strPlayerName;}
   void                  SetPlayerName(LPCTSTR);

   void SetSkillLevelCustom(const SIZE& newSizeMosaic, int numberMines);

   SIZE                  GetSize(const SIZE &sizeMosaic, int iArea) const {return GetSize(m_Body.m_Mosaic.GetSizeWindow(   sizeMosaic  , iArea));}  //       ( )     
   SIZE                  GetSize(int iArea)                         const {return GetSize(m_Body.m_Mosaic.GetSizeWindow(GetSizeMosaic(), iArea));}  //        ( )     
   SIZE                  GetSize(const SIZE  &sizeMosaicInPixel)    const;                                                                   //        ( )
   SIZE                  GetSize()                                  const {return GetSize(GetSizeMosaicWindow());}                           //        ( )   
   SIZE                  GetSizeMosaic              () const {return m_Body.m_Mosaic.GetSize();}
   SIZE                  GetSizeMosaicWindow        () const {return m_Body.m_Mosaic.GetSizeWindow(GetSizeMosaic(), GetArea());}
   int                   GetArea                    () const {return m_Body.m_Mosaic.GetArea();}
   int                   GetMines                   () const {return m_Body.m_Mosaic.GetMines();}
   UINT                  GetMaxMines(const SIZE &size) const {return m_Body.m_Mosaic.GetMaxMines(size);} //  -     
   int                   GetMosaicNeighborNumber    () const {return m_Body.m_Mosaic.GetNeighborNumber();}
   ESkillLevel           GetSkillLevel              () const {return m_Body.m_Mosaic.GetSkillLevel();}
   EMosaic               GetMosaic                  () const {return m_Body.m_Mosaic.GetMosaic();}
   bool                  SetMosaic(EMosaic);
   int DefineNumberMines(ESkillLevel skill, const SIZE &sizeMosaic) const {return CMosaic::DefineNumberMines(skill, m_Body.m_Mosaic.GetMosaic(), sizeMosaic);};
   int DefineNumberMines() const {return CMosaic::DefineNumberMines(GetSkillLevel(), m_Body.m_Mosaic.GetMosaic(), GetSizeMosaic());};

   const CImageSerialize& GetImageBtnNew  (int pos) const {return m_Body.m_Skin.m_ImgBtnNew  [pos];}
   const CImageSerialize& GetImageBtnPause(int pos) const {return m_Body.m_Skin.m_ImgBtnPause[pos];}
   static const CImage& GetImageMosaic(EMosaic eMosaic);
   static const HICON   GetIconMosaic (EMosaic eMosaic);

   HMENU GetSkinSubMenu() const;

   void Menu_ChangeLanguage();

   CPlayers& GetPlayers() { return m_Players; }
   void LoadAllFiles();
};

#endif // __FILE__FASTMINES2__
