////////////////////////////////////////////////////////////////////////////////
// File name: EnumObj.cpp
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru
// Date: 2006 03 09
//
// Description:     help -
////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <Windows.h>
#include <Tlhelp32.h>
#include "CommonLib.h"
#include "Logger.h"

#if defined _DEBUG && defined __AFX_H__
   #undef THIS_FILE
   static char THIS_FILE[]=__FILE__;
   #define new DEBUG_NEW
#endif
/*
//#define __SDK__    //  ,   SDK
//#define __NT_DDK__ //  ,   DDK
#ifdef __NT_DDK__
   namespace NT {
      extern "C" {
         #pragma warning(disable:4005)
         #include <ntddk.h> // need DDK
         #pragma warning(default:4005)
      }
   }
   using NT::NTSTATUS;
#else
   #ifdef __SDK__
      namespace NT {
         extern "C" {
            #pragma warning(disable:4005)
            #include "ntstatus.h"
            #pragma warning(default:4005)
         }
      }
   #endif // __SDK__
#endif // __NT_DDK__

#ifdef __SDK__
   #include <WInternl.h>
   #include <PsApi.h>
   #pragma comment(lib, "PsApi")
#endif // __SDK__
#include <TlHelp32.h>
#include <stddef.h>
#pragma comment(lib, "Version")
#include <crtdbg.h>

#include <WTypes.h>
#include <oleauto.h>
#include <AtlConv.h>

#include <TChar.h>
#include <Vector>
/**/
#include "EnumObj.h"

#ifndef __FILE__LOGGER__
   #ifdef TRACE
      #define LOG_PUT(pLogger, pFunction, logLevel) ::AfxTrace(_T("\r\n")); ::AfxTrace(
   #else
      inline void OutputDebugStringF(LPCTSTR lpszFormat, ...) {
         va_list arglist;
         va_start(arglist, lpszFormat);
         CString strRes;
         strRes.FormatV(lpszFormat, arglist);
         va_end(arglist);
         strRes += _T("\r\n");
         ::OutputDebugString(strRes);
      }
      #define LOG_PUT(pLogger, pFunction, logLevel) ::OutputDebugStringF(
   #endif
#endif

/*******************************************************************************************/
//
//          Types defenitions
//
/*******************************************************************************************/

//        DDK
namespace NT {
   #ifndef _NTDEF_
      #define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)
   #endif // _NTDEF_

   #ifndef _NTDDK_
      typedef LONG KPRIORITY;
      typedef struct _CLIENT_ID {
         DWORD UniqueProcess;
         DWORD UniqueThread;
      } CLIENT_ID;
      typedef struct _VM_COUNTERS {
         SIZE_T PeakVirtualSize;
         SIZE_T VirtualSize;
         ULONG  PageFaultCount;
         SIZE_T PeakWorkingSetSize;
         SIZE_T WorkingSetSize;
         SIZE_T QuotaPeakPagedPoolUsage;
         SIZE_T QuotaPagedPoolUsage;
         SIZE_T QuotaPeakNonPagedPoolUsage;
         SIZE_T QuotaNonPagedPoolUsage;
         SIZE_T PagefileUsage;
         SIZE_T PeakPagefileUsage;
      } VM_COUNTERS;
      typedef struct _IO_COUNTERS {
         ULONGLONG ReadOperationCount;
         ULONGLONG WriteOperationCount;
         ULONGLONG OtherOperationCount;
         ULONGLONG ReadTransferCount;
         ULONGLONG WriteTransferCount;
         ULONGLONG OtherTransferCount;
      } IO_COUNTERS;
   #endif // _NTDDK_
   #ifndef _NTSTATUS_
      #define STATUS_SUCCESS              ((NTSTATUS)0x00000000L) // ntsubauth
      #define STATUS_INFO_LENGTH_MISMATCH ((NTSTATUS)0xC0000004L) //  The specified information record length does not match the length required for the specified information class.
   #endif // _NTSTATUS_
} // namespace NT



//        SDK
#ifndef _PSAPI_H_
   typedef struct _MODULEINFO {
       LPVOID lpBaseOfDll;
       DWORD SizeOfImage;
       LPVOID EntryPoint;
   } MODULEINFO, *LPMODULEINFO;
#endif // _PSAPI_H_
#ifndef _WINTERNL_
   typedef struct _UNICODE_STRING {
       USHORT Length;
       USHORT MaximumLength;
       PWSTR  Buffer;
   } UNICODE_STRING;
   typedef LONG NTSTATUS;
   typedef enum _SYSTEM_INFORMATION_CLASS {
      SystemBasicInformation = 0,
      SystemPerformanceInformation = 2,
      SystemTimeOfDayInformation = 3,
      SystemProcessInformation = 5,
      SystemProcessorPerformanceInformation = 8,
      SystemInterruptInformation = 23,
      SystemExceptionInformation = 33,
      SystemRegistryQuotaInformation = 37,
      SystemLookasideInformation = 45
   } SYSTEM_INFORMATION_CLASS;
#endif // _WINTERNL_



//     Microsoft
typedef enum _THREAD_STATE {
   StateInitialized,
   StateReady,
   StateRunning,
   StateStandby,
   StateTerminated,
   StateWait,
   StateTransition,
   StateUnknown
} THREAD_STATE;

typedef enum _KWAIT_REASON {
   Executive,
   FreePage,
   PageIn,
   PoolAllocation,
   DelayExecution,
   Suspended,
   UserRequest,
   WrExecutive,
   WrFreePage,
   WrPageIn,
   WrPoolAllocation,
   WrDelayExecution,
   WrSuspended,
   WrUserRequest,
   WrEventPair,
   WrQueue,
   WrLpcReceive,
   WrLpcReply,
   WrVirtualMemory,
   WrPageOut,
   WrRendezvous,
   Spare2,
   Spare3,
   Spare4,
   Spare5,
   Spare6,
   WrKernel
} KWAIT_REASON;

typedef struct _SYSTEM_THREADS {
   LARGE_INTEGER  KernelTime;
   LARGE_INTEGER  UserTime;
   LARGE_INTEGER  CreateTime;
   ULONG          WaitTime;
   PVOID          StartAddress;
   NT::CLIENT_ID  ClientId;
   NT::KPRIORITY  Priority;
   NT::KPRIORITY  BasePriority;
   ULONG          ContextSwitchCount;
   THREAD_STATE   State;
   KWAIT_REASON   WaitReason;
} SYSTEM_THREADS;

typedef struct _SYSTEM_PROCESSES {
   ULONG             NextEntryDelta;
   ULONG             ThreadCount;
   ULONG             Reserved1[6];
   LARGE_INTEGER     CreateTime;
   LARGE_INTEGER     UserTime;
   LARGE_INTEGER     KernelTime;
   UNICODE_STRING    ProcessName;
   NT::KPRIORITY     BasePriority;
   ULONG             ProcessId;
   ULONG             InheritedFromProcessId;
   ULONG             HandleCount;
   ULONG             Reserved2[2];
 //ULONG             PivatePageCount;
   NT::VM_COUNTERS   VmCounters;
#if _WIN32_WINNT >= 0x500
   NT::IO_COUNTERS   IoCounters;
#endif
   SYSTEM_THREADS    Threads[1];
} SYSTEM_PROCESSES;

/*******************************************************************************************/
//
//          My help functions
//
/*******************************************************************************************/

__forceinline CString SystemTime2Str(const SYSTEMTIME &st) {
   CString strRes;
   strRes.Format(_T("%04i.%02i.%02i %02i:%02i:%02i,%03i"), int(st.wYear), int(st.wMonth), int(st.wDay), int(st.wHour), int(st.wMinute), int(st.wSecond), int(st.wMilliseconds));
   return strRes;
}

/*******************************************************************************************/
//
//             Using Tool Help Functions
//
// Functions:
// - SnapshotProcesses
// - SnapshotModules
// - SnapshotThreads
/*******************************************************************************************/
BOOL SnapshotProcesses(OUT PROCESS_INFO::VECTOR &listProcesses) {
   HANDLE hProcessSnap = ::CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
   BOOL bRes = (hProcessSnap != INVALID_HANDLE_VALUE);
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  SnapshotProcesses:     : CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS): "), dwErrCode);
   } else {
      PROCESSENTRY32 pe = {sizeof(PROCESSENTRY32), /*...*/};
      bRes = ::Process32First(hProcessSnap, &pe);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  SnapshotProcesses:           : Process32First: "), dwErrCode);
      } else {
         listProcesses.clear();
         do {
            listProcesses.push_back(PROCESS_INFO(pe.szExeFile, pe.th32ProcessID, pe.cntThreads, pe.th32ParentProcessID, pe.pcPriClassBase));

            //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  SnapshotProcesses: Process [%s], PID %i, thread count %i, parent PID %i, base Priority %i"), pe.szExeFile, pe.th32ProcessID, pe.cntThreads, pe.th32ParentProcessID, pe.pcPriClassBase);
            bRes = ::Process32Next(hProcessSnap, &pe);
            if (!bRes) {
               dwErrCode = ::GetLastError();
               if (dwErrCode == ERROR_NO_MORE_FILES) {
                  bRes = TRUE;
               } else {
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  SnapshotProcesses:          : Process32Next: "), dwErrCode);
               }
               break;
            }
         } while(true);
      }
      ::CloseHandle(hProcessSnap);
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL SnapshotModules(OUT MODULE_INFO::VECTOR &listModules, IN DWORD dwProcessID) {
   HANDLE hModuleSnap = ::CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessID);
   BOOL bRes = (hModuleSnap != INVALID_HANDLE_VALUE);
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  SnapshotModules:       (PID=%i): CreateToolhelp32Snapshot(TH32CS_SNAPMODULE): "), dwProcessID), dwErrCode);
   } else {
      MODULEENTRY32 me = {sizeof(MODULEENTRY32), /*...*/};
      bRes = ::Module32First(hModuleSnap, &me);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  SnapshotModules:            (PID=%i): Module32First: "), dwProcessID), dwErrCode);
      } else {
         listModules.clear();
         do {
            listModules.push_back(MODULE_INFO(me.szModule, me.szExePath, me.modBaseAddr, me.modBaseSize));

            LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  SnapshotModules: Address [0x%08X - 0x%08X], Module [%s]"), me.modBaseAddr, me.modBaseAddr+me.modBaseSize-1, me.szExePath);
            bRes = ::Module32Next(hModuleSnap, &me);
            if (!bRes) {
               dwErrCode = ::GetLastError();
               if (dwErrCode == ERROR_NO_MORE_FILES) {
                  bRes = TRUE;
               } else {
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  SnapshotModules:            (PID=%i): Module32Next: "), dwProcessID), dwErrCode);
               }
               break;
            }
         } while(true);
      }
      ::CloseHandle(hModuleSnap);
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL SnapshotThreads(OUT THREAD_INFO::VECTOR &listThreads1, IN DWORD dwProcessID) {
   if (dwProcessID == 0) {
      dwProcessID = ::GetCurrentThreadId();
   }
   HANDLE hModuleSnap = ::CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
   BOOL bRes = (hModuleSnap != INVALID_HANDLE_VALUE);
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  SnapshotThreads:       (PID=%i): CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD): "), dwProcessID), dwErrCode);
   } else {
      THREADENTRY32 te = {sizeof(THREADENTRY32), /*...*/};
      bRes = ::Thread32First(hModuleSnap, &te);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  SnapshotThreads:            (PID=%i): Thread32First: "), dwProcessID), dwErrCode);
      } else {
         listThreads1.clear();
         do {
            if (dwProcessID == te.th32OwnerProcessID) {
               listThreads1.push_back(THREAD_INFO(te.cntUsage, te.th32ThreadID, te.tpBasePri, te.tpDeltaPri));
               //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  SnapshotThreads: Thread ID 0x%08X, Owner PID 0x%08X, Usage %i, Base Priority %i, Delta Priority %i"), te.th32ThreadID, te.th32OwnerProcessID, te.cntUsage, te.tpBasePri, te.tpDeltaPri);
            }

            bRes = ::Thread32Next(hModuleSnap, &te);
            if (!bRes) {
               dwErrCode = ::GetLastError();
               if (dwErrCode == ERROR_NO_MORE_FILES) {
                  bRes = TRUE;
               } else {
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  SnapshotThreads:            (PID=%i): Thread32Next: "), dwProcessID), dwErrCode);
               }
               break;
            }
         } while(true);
      }
      ::CloseHandle(hModuleSnap);
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

/*******************************************************************************************/
//
//             Using Process Status Helper Functions (Process status API (PSAPI))
//
// Functions:
// - EnumProcesses
// - EnumModules
/*******************************************************************************************/

BOOL EnumProcesses(OUT PROCESS_INFO::VECTOR &listProcesses) {
   typedef BOOL (WINAPI *PEnumProcesses)(DWORD *lpidProcess, DWORD cb, DWORD *cbNeeded); // see <PsApi.h> func EnumProcesses

   BOOL bRes = TRUE;
   DWORD dwErrCode = ERROR_SUCCESS;

#ifdef _PSAPI_H_
   PEnumProcesses pEnumProcesses = EnumProcesses;
#else
   PEnumProcesses pEnumProcesses = NULL;
   HMODULE hModule = ::LoadLibrary(_T("PsApi.dll"));
   bRes = (hModule != NULL);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses: LoadLibrary('PsApi.dll'): "), dwErrCode);
   }
   if (bRes) {
      pEnumProcesses = (PEnumProcesses)::GetProcAddress(hModule, "EnumProcesses");
      bRes = (pEnumProcesses != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses: GetProcAddress('PsApi.dll', 'EnumProcesses'): "), dwErrCode);
      }
   }
#endif

   if (bRes) {
      DWORD aProcesses[1024];
      DWORD cb = sizeof(aProcesses);
      DWORD dwNeeded = 0;
      bRes = pEnumProcesses(aProcesses, cb, &dwNeeded);
      if (!bRes || !dwNeeded) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses:      : EnumProcesses: "), dwErrCode);
      } else {
         listProcesses.clear();
         for (int i=0; i<(dwNeeded/sizeof(DWORD)); i++) {
            listProcesses.push_back(PROCESS_INFO());
            const DWORD &dwProcessID = aProcesses[i];
            listProcesses[i].m_dwProcessID = dwProcessID;

            MODULE_INFO::VECTOR listModules;
            BOOL bRes2 = EnumModules(listModules, dwProcessID);
            if (!bRes2) {
               DWORD dwErrCode2 = ::GetLastError();
               LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumProcesses:        (PID=%i): EnumModules: "), dwProcessID), dwErrCode2);
            }
            if (listModules.size()>0) {
               listProcesses[i].m_strExeFile = listModules[0].m_strExePath;
            }

            LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  EnumProcesses: Process [%s], PID %i"), listProcesses[i].m_strExeFile, dwProcessID);
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL EnumModules(OUT MODULE_INFO::VECTOR &listModules, IN DWORD dwProcessID) {
   typedef BOOL  (WINAPI *PEnumProcessModules  )(HANDLE hProcess, HMODULE *lphModule, DWORD cb, LPDWORD lpcbNeeded);  // see <PsApi.h> func EnumProcessModules
   typedef DWORD (WINAPI *PGetModuleFileNameEx )(HANDLE hProcess, HMODULE hModule, LPTSTR lpFilename, DWORD nSize);   // see <PsApi.h> func GetModuleFileNameEx
   typedef BOOL  (WINAPI *PGetModuleInformation)(HANDLE hProcess, HMODULE hModule, LPMODULEINFO lpmodinfo, DWORD cb); // see <PsApi.h> func GetModuleInformation

   BOOL bRes = TRUE;
   DWORD dwErrCode = ERROR_SUCCESS;

#ifdef _PSAPI_H_
   PEnumProcessModules   pEnumProcessModules   = EnumProcessModules;
   PGetModuleFileNameEx  pGetModuleFileNameEx  = GetModuleFileNameEx;
   PGetModuleInformation pGetModuleInformation = GetModuleInformation;
#else
   PEnumProcessModules   pEnumProcessModules   = NULL;
   PGetModuleFileNameEx  pGetModuleFileNameEx  = NULL;
   PGetModuleInformation pGetModuleInformation = NULL;
   HMODULE hModule = ::LoadLibrary(_T("PsApi.dll"));
   bRes = (hModule != NULL);
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumModules: LoadLibrary('PsApi.dll'): "), dwErrCode);
   }
   if (bRes) {
      pEnumProcessModules = (PEnumProcessModules)::GetProcAddress(hModule, "EnumProcessModules");
      bRes = (pEnumProcessModules != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumModules: GetProcAddress('PsApi.dll', 'EnumProcessModules'): "), dwErrCode);
      }

#ifdef _UNICODE
      pGetModuleFileNameEx = (PGetModuleFileNameEx)::GetProcAddress(hModule, "GetModuleFileNameExW");
#else
      pGetModuleFileNameEx = (PGetModuleFileNameEx)::GetProcAddress(hModule, "GetModuleFileNameExA");
#endif // _UNIODE
      bRes &= (pGetModuleFileNameEx != NULL);
      if ((pGetModuleFileNameEx == NULL)) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumModules: GetProcAddress('PsApi.dll', 'GetModuleFileNameEx'): "), dwErrCode);
      }

      pGetModuleInformation = (PGetModuleInformation)::GetProcAddress(hModule, "GetModuleInformation");
      bRes &= (pGetModuleInformation != NULL);
      if (pGetModuleInformation == NULL) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumModules: GetProcAddress('PsApi.dll', 'GetModuleInformation'): "), dwErrCode);
      }
   }
#endif

   HANDLE hProcess = NULL;
   if (bRes) {
      if (dwProcessID == 0) {
         hProcess = ::GetCurrentProcess();
      } else {
         hProcess = ::OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, dwProcessID);
         bRes = (hProcess != NULL);
         if (!bRes) {
            dwErrCode = ::GetLastError();
            LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumModules:       (PID=%i): OpenProcess(PROCESS_QUERY_INFORMATION | PROCESS_VM_READ): "), dwProcessID), dwErrCode);
         }
      }
   }
   if (bRes) {
      DWORD dwNeeded = 0;
      bRes = pEnumProcessModules(hProcess, NULL, 0, &dwNeeded);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumModules:             (PID=%i): EnumProcessModules: "), dwProcessID), dwErrCode);
      } else {
         HMODULE *hMods = NULL;
         try { hMods = (HMODULE*)(new BYTE [dwNeeded]); } catch(...) {}
         if (hMods == NULL) {
            dwErrCode = ERROR_OUTOFMEMORY;
            LOG_PUT(g_pLog, Put, LL_ERROR) _T("  EnumModules:     (%i )       (PID=%i): "), dwNeeded, dwProcessID);
         } else {
            DWORD dwSize = dwNeeded;
            bRes = pEnumProcessModules(hProcess, hMods, dwSize, &dwNeeded);
            if (!bRes) {
               dwErrCode = ::GetLastError();
               LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumModules:         (PID=%i): EnumProcessModules: "), dwProcessID), dwErrCode);
            } else {
               if (dwSize != dwNeeded) {
                  LOG_PUT(g_pLog, Put, LL_WARNING) ::Format(_T("  EnumModules:  (%i )   (%i )         (PID=%i) : EnumProcessModules: "), dwSize, dwNeeded, dwProcessID));
               }
               listModules.clear();
               for (int i=0; i<(dwNeeded/sizeof(HMODULE)); i++) {
                  listModules.push_back(MODULE_INFO());

                  // Get the full path to the module's file.
                  TCHAR szModName[MAX_PATH] = {0};
                  BOOL bRes2 = (0 != pGetModuleFileNameEx(hProcess, hMods[i], szModName, sizeof(szModName)));
                  if (!bRes2) {
                     DWORD dwErrCode2 = ::GetLastError();
                     LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumModules:       %i   (PID=%i): GetModuleFileNameEx: "), i, dwProcessID), dwErrCode2);
                  } else {
                     listModules[i].m_strExePath = szModName;
                  }

                  // Module info
                  MODULEINFO mi = {NULL, 0, NULL};
                  bRes2 = pGetModuleInformation(hProcess, hMods[i], &mi, sizeof(MODULEINFO));
                  if (!bRes2) {
                     DWORD dwErrCode2 = ::GetLastError();
                     BOOL bEmpty = listModules[i].m_strExePath.IsEmpty();
                     LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumModules:       %i%s   (PID=%i): GetModuleInformation: "), i, (LPCTSTR)(bEmpty ? _T("") : (LPCTSTR)(_T(" [")+listModules[i].m_strExePath+_T("]"))), dwProcessID), dwErrCode2);
                  } else {
                     listModules[i].m_pModBaseAddr = (BYTE*)mi.lpBaseOfDll;
                     listModules[i].m_pModBaseSize = mi.SizeOfImage;
                  }

                  LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  EnumModules: Address [0x%08X - 0x%08X], Module [%s]"), listModules[i].m_pModBaseAddr, listModules[i].m_pModBaseAddr+listModules[i].m_pModBaseSize-1, LPCTSTR(listModules[i].m_strExePath));
               }
            }
            delete [] hMods; hMods = NULL;
         }
      }
   }
   if (hProcess && (dwProcessID != 0)) {
      BOOL bRes2 = ::CloseHandle(hProcess);
      if (!bRes2) {
         DWORD dwErrCode2 = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumModules:      (PID=%i): CloseHandle: "), dwProcessID), dwErrCode2);
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

/*******************************************************************************************/
//
//             Using NT kernel functions NtQuerySystemInformation
//
// Functions:
// - EnumProcesses2
// - EnumThreads
/*******************************************************************************************/

BOOL EnumProcesses2(OUT PROCESS_INFO::VECTOR &listProcesses) {
   typedef NTSTATUS (WINAPI *PNtQuerySystemInformation)(SYSTEM_INFORMATION_CLASS, PVOID, ULONG, PULONG); // see NtQuerySystemInformation in <WInternl.h>
   PNtQuerySystemInformation pNtQuerySystemInformation = NULL;

   HMODULE hModule = ::GetModuleHandle(_T("ntdll.dll"));
   BOOL bRes = (hModule != NULL);
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses2: GetModuleHandle('ntdll.dll'): "), dwErrCode);
      hModule = ::LoadLibrary(_T("ntdll.dll"));
      bRes = (hModule != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses2: LoadLibrary('ntdll.dll'): "), dwErrCode);
      }
   }
   if (bRes) {
      pNtQuerySystemInformation = (PNtQuerySystemInformation)::GetProcAddress(hModule, "NtQuerySystemInformation");//"ZwQuerySystemInformation");
      bRes = (pNtQuerySystemInformation != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses2: GetProcAddress('ntdll.dll', 'NtQuerySystemInformation'): "), dwErrCode);
      }
   }

   HANDLE hHeap = ::GetProcessHeap();
   if (bRes) {
      bRes = (hHeap != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses2: GetProcessHeap: "), dwErrCode);
      }
   }

   SYSTEM_PROCESSES *pProcesses = NULL;
   ULONG cbBuffer = 0x8000;
   PVOID pBuffer = NULL;
   if (bRes) {
      NTSTATUS ntStatus = STATUS_SUCCESS;
      do {
         pBuffer = ::HeapAlloc(hHeap, 0, cbBuffer);
         bRes = (pBuffer != NULL);
         if (!bRes) {
            dwErrCode = ::GetLastError();
            LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumProcesses2:  %i : HeapAlloc: "), cbBuffer), dwErrCode);
         } else {
            ntStatus = pNtQuerySystemInformation(SystemProcessInformation, pBuffer, cbBuffer, NULL);;
            bRes = NT_SUCCESS(ntStatus);

            if (!bRes) {
               BOOL bRes2 = ::HeapFree(hHeap, 0, pBuffer);
               if (!bRes2) {
                  DWORD dwErrCode2 = ::GetLastError();
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumProcesses2:  %i  ( 0x%08X): HeapFree: "), cbBuffer, pBuffer), dwErrCode2);
               }
               if (ntStatus == STATUS_INFO_LENGTH_MISMATCH) {
                  cbBuffer = cbBuffer<<1;
               } else {
                  dwErrCode = ntStatus;
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcesses2: NtQuerySystemInformation(SystemProcessInformation): "), ntStatus);
               }
            } else {
               pProcesses = (SYSTEM_PROCESSES*)pBuffer;
            }
         }
      } while (ntStatus == STATUS_INFO_LENGTH_MISMATCH);
   }
   if (pProcesses) {
      listProcesses.clear();
      for (;;) {
         PCWSTR szProcessName = pProcesses->ProcessName.Buffer ? pProcesses->ProcessName.Buffer : L"Idle";
         USES_CONVERSION;
         listProcesses.push_back(PROCESS_INFO(W2CT(szProcessName), pProcesses->ProcessId, pProcesses->ThreadCount, pProcesses->InheritedFromProcessId, pProcesses->BasePriority));
         LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  EnumProcesses2: Process [%s], PID %i, thread count %i, parent PID %i, base Priority %i"), (LPCTSTR)W2CT(szProcessName), pProcesses->ProcessId, pProcesses->ThreadCount, pProcesses->InheritedFromProcessId, pProcesses->BasePriority);

         if (pProcesses->NextEntryDelta == 0) break;
         pProcesses = (SYSTEM_PROCESSES*)(((LPBYTE)pProcesses)+ pProcesses->NextEntryDelta);
      }
   }
   if (pBuffer) {
      BOOL bRes2 = ::HeapFree(hHeap, 0, pBuffer);
      if (!bRes2) {
         DWORD dwErrCode2 = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumProcesses2:  %i  ( 0x%08X): HeapFree: "), cbBuffer, pBuffer), dwErrCode2);
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL EnumThreads(OUT THREAD_INFO2::VECTOR &listThreads1, IN DWORD dwProcessID) {
   typedef NTSTATUS (WINAPI *PNtQuerySystemInformation)(SYSTEM_INFORMATION_CLASS, PVOID, ULONG, PULONG); // see NtQuerySystemInformation in <WInternl.h>
   PNtQuerySystemInformation pNtQuerySystemInformation = NULL;

   HMODULE hModule = ::GetModuleHandle(_T("ntdll.dll"));
   BOOL bRes = (hModule != NULL);
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!bRes) {
      dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumThreads: GetModuleHandle('ntdll.dll'): "), dwErrCode);
      hModule = ::LoadLibrary(_T("ntdll.dll"));
      bRes = (hModule != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumThreads: LoadLibrary('ntdll.dll'): "), dwErrCode);
      }
   }
   if (bRes) {
      pNtQuerySystemInformation = (PNtQuerySystemInformation)::GetProcAddress(hModule, "NtQuerySystemInformation");//"ZwQuerySystemInformation");
      bRes = (pNtQuerySystemInformation != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumThreads: GetProcAddress('ntdll.dll', 'NtQuerySystemInformation'): "), dwErrCode);
      }
   }

   HANDLE hHeap = ::GetProcessHeap();
   if (bRes) {
      bRes = (hHeap != NULL);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumThreads: GetProcessHeap: "), dwErrCode);
      }
   }

   SYSTEM_PROCESSES *pProcesses = NULL;
   ULONG cbBuffer = 0x8000;
   PVOID pBuffer = NULL;
   if (bRes) {
      NTSTATUS ntStatus = STATUS_SUCCESS;
      do {
         pBuffer = ::HeapAlloc(hHeap, 0, cbBuffer);
         bRes = (pBuffer != NULL);
         if (!bRes) {
            dwErrCode = ::GetLastError();
            LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumThreads:  %i : HeapAlloc: "), cbBuffer), dwErrCode);
         } else {
            ntStatus = pNtQuerySystemInformation(SystemProcessInformation, pBuffer, cbBuffer, NULL);;
            bRes = NT_SUCCESS(ntStatus);

            if (!bRes) {
               BOOL bRes2 = ::HeapFree(hHeap, 0, pBuffer);
               if (!bRes2) {
                  DWORD dwErrCode2 = ::GetLastError();
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumThreads:  %i  ( 0x%08X): HeapFree: "), cbBuffer, pBuffer), dwErrCode2);
               }
               if (ntStatus == STATUS_INFO_LENGTH_MISMATCH) {
                  cbBuffer = cbBuffer<<1;
               } else {
                  dwErrCode = ntStatus;
                  LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumThreads: NtQuerySystemInformation(SystemProcessInformation): "), ntStatus);
               }
            } else {
               pProcesses = (SYSTEM_PROCESSES*)pBuffer;
            }
         }
      } while (ntStatus == STATUS_INFO_LENGTH_MISMATCH);
   }
   if (pProcesses) {
      for (;;) {
         PCWSTR szProcessName = pProcesses->ProcessName.Buffer ? pProcesses->ProcessName.Buffer : L"Idle";
         USES_CONVERSION;
         LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  EnumThreads: Process name [%s] "), (LPCTSTR)W2CT(szProcessName));

         if (pProcesses->ProcessId == dwProcessID) {
            listThreads1.clear();
            for (int i=0; i < pProcesses->ThreadCount; i++) {
               SYSTEM_THREADS &t = pProcesses->Threads[i];
               FILETIME ftCreateTime = {t.CreateTime.LowPart, t.CreateTime.HighPart};
               SYSTEMTIME stCreateTime = ::FileTimeToSystemTime(FileTimeToLocalFileTime(ftCreateTime));
               listThreads1.push_back(THREAD_INFO2(DWORD(t.ClientId.UniqueThread), (PBYTE)t.StartAddress, stCreateTime, t.Priority, t.BasePriority));
               LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  EnumThreads: Thread ID - 0x%08X, CreateTime [%s], StartAdress - 0x%08X, Priority - %i, Base Priority - %i"), t.ClientId.UniqueThread, (LPCTSTR)SystemTime2Str(stCreateTime), t.StartAddress, t.Priority, t.BasePriority);
            }
            break;
         }
         if (pProcesses->NextEntryDelta == 0) break;
         pProcesses = (SYSTEM_PROCESSES*)(((LPBYTE)pProcesses)+ pProcesses->NextEntryDelta);
      }
   }
   if (pBuffer) {
      BOOL bRes2 = ::HeapFree(hHeap, 0, pBuffer);
      if (!bRes2) {
         DWORD dwErrCode2 = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumThreads:  %i  ( 0x%08X): HeapFree: "), cbBuffer, pBuffer), dwErrCode2);
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

DWORD ProcessID(LPCTSTR szProcessName) {
   PROCESS_INFO::VECTOR listProcesses;
   ::SnapshotProcesses(listProcesses);
   for (PROCESS_INFO::VECTOR::const_iterator I = listProcesses.begin(); I!=listProcesses.end(); I++) {
      const PROCESS_INFO &ItemProcess = (*I);
      CString strExeFile(ItemProcess.m_strExeFile);
      if (0==strExeFile.CompareNoCase(szProcessName)) {
         return ItemProcess.m_dwProcessID;
      }
   }
   return 0;
}

DWORD ParentProcessID(LPCTSTR szProcessName) {
   PROCESS_INFO::VECTOR listProcesses;
   ::SnapshotProcesses(listProcesses);
   for (PROCESS_INFO::VECTOR::const_iterator I = listProcesses.begin(); I!=listProcesses.end(); I++) {
      const PROCESS_INFO &ItemProcess = (*I);
      CString strExeFile(ItemProcess.m_strExeFile);
      if (0==strExeFile.CompareNoCase(szProcessName)) {
         return ItemProcess.m_dwParentProcessID;
      }
   }
   return 0;
}

CString ProcessName(DWORD dwProcessID) {
   PROCESS_INFO::VECTOR listProcesses;
   BOOL bRes = ::SnapshotProcesses(listProcesses);
   for (PROCESS_INFO::VECTOR::const_iterator I = listProcesses.begin(); I!=listProcesses.end(); I++) {
      const PROCESS_INFO &ItemProcess = (*I);
      if (ItemProcess.m_dwProcessID == dwProcessID)
         return ItemProcess.m_strExeFile;
   }
   return _T('\0');
}
/*******************************************************************************************/
//  enum Windows
/*******************************************************************************************/
struct CEnumWindowParam {
   VECTOR_HWND &m_vecHWND;
   int          m_iNesting;
   CEnumWindowParam(VECTOR_HWND &vecHWND) : m_vecHWND(vecHWND), m_iNesting(1) {}
};

BOOL CALLBACK Debug_EnumChildWindowFunc(HWND hWnd, LPARAM lParam) {
   CEnumWindowParam *pContext = (CEnumWindowParam*)lParam;
   if (pContext == NULL) {
      return FALSE;
   } else {
      pContext->m_iNesting++;
    //LOG_PUT(g_pLog, Put, LL_DEBUG) CString(' ', 3*pContext->m_iNesting)+_T("hWnd 0x%08X, class [%s], title [%s]; parent 0x%08X, parent class [%s], parent title [%s]"), hWnd, (LPCTSTR)::GetClassName(hWnd), (LPCTSTR)::GetWindowText(hWnd), ::GetParent(hWnd), (LPCTSTR)::GetClassName(GetParent(hWnd)), (LPCTSTR)::GetWindowText(GetParent(hWnd)));
      LOG_PUT(g_pLog, Put, LL_DEBUG) CString(' ', 3*pContext->m_iNesting)+_T("hWnd 0x%08X, class [%s], idControl=0x%04X(%i), title [%s]"), hWnd, (LPCTSTR)::GetClassName(hWnd), ::GetDlgCtrlID(hWnd), ::GetDlgCtrlID(hWnd), (LPCTSTR)::GetWindowText(hWnd));
      ::EnumChildWindows(hWnd, Debug_EnumChildWindowFunc, lParam);
      pContext->m_iNesting--;
      return TRUE;
   }
}

BOOL CALLBACK Debug_EnumThreadWindowFunc(HWND hWnd, LPARAM lParam) {
   CEnumWindowParam *pContext = (CEnumWindowParam*)lParam;
   if (pContext == NULL) {
      return FALSE;
   } else {
      pContext->m_iNesting++;
      pContext->m_vecHWND.push_back(hWnd);
      LOG_PUT(g_pLog, Put, LL_DEBUG) CString(' ', 3*pContext->m_iNesting)+_T("------------------------------------"));
      LOG_PUT(g_pLog, Put, LL_DEBUG) CString(' ', 3*pContext->m_iNesting)+_T("hWnd 0x%08X, class [%s], title [%s]; parent 0x%08X, parent class [%s], parent title [%s]"), hWnd, (LPCTSTR)::GetClassName(hWnd), (LPCTSTR)::GetWindowText(hWnd), ::GetParent(hWnd), (LPCTSTR)::GetClassName(GetParent(hWnd)), (LPCTSTR)::GetWindowText(GetParent(hWnd)));
      ::EnumChildWindows(hWnd, Debug_EnumChildWindowFunc, lParam);
      pContext->m_iNesting--;
      return TRUE;
   }
}

/* private */ void EnumProcessWindows(DWORD dwProcessID, VECTOR_HWND &vecHWND) {
   THREAD_INFO::VECTOR listThreads;
   BOOL bRes = ::SnapshotThreads(listThreads, dwProcessID);
   for (THREAD_INFO::VECTOR::const_iterator J = listThreads.begin(); J!=listThreads.end(); J++) {
      const THREAD_INFO &ItemThread = (*J);
      //::SetLastError(0);
      LOG_PUT(g_pLog, Put, LL_DEBUG) _T("   ===================================="));
      LOG_PUT(g_pLog, Put, LL_DEBUG) _T("   Thread ID 0x%08X"), ItemThread.m_th32ThreadID);
      bRes &= ::EnumThreadWindows(ItemThread.m_th32ThreadID, Debug_EnumThreadWindowFunc, (LPARAM)&CEnumWindowParam(vecHWND));
      //DWORD dwErrCode = ::GetLastError();
      //if (dwErrCode != ERROR_SUCCESS) {
      //   LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  EnumProcessWindows: EnumThreadWindows: "), dwErrCode);
      //}
   }
}

VECTOR_HWND EnumProcessWindows(LPCTSTR szProcessName) {
   VECTOR_HWND vecHWND;
   PROCESS_INFO::VECTOR listProcesses;
   BOOL bRes = ::SnapshotProcesses(listProcesses);
   for (PROCESS_INFO::VECTOR::const_iterator I = listProcesses.begin(); I!=listProcesses.end(); I++) {
      const PROCESS_INFO &ItemProcess = (*I);
      BOOL bCompare = (szProcessName && szProcessName[0]) ? (0==ItemProcess.m_strExeFile.CompareNoCase(szProcessName)) : FALSE;
      if ((szProcessName == NULL) || bCompare) {
         LOG_PUT(g_pLog, Put, LL_DEBUG) _T("************************************"));
         LOG_PUT(g_pLog, Put, LL_DEBUG) _T("Process '%s'"), (LPCTSTR)ItemProcess.m_strExeFile);

         if (ItemProcess.m_dwProcessID) {
            EnumProcessWindows(ItemProcess.m_dwProcessID, vecHWND);
         }
         if (bCompare)
            break;
      }
   }
   return vecHWND;
}


VECTOR_HWND EnumProcessWindows(DWORD dwProcessID) {
   if (dwProcessID == 0) {
      return EnumProcessWindows((LPCTSTR)NULL);
   }

   VECTOR_HWND vecHWND;
   EnumProcessWindows(dwProcessID, vecHWND);
   return vecHWND;
}

//    
BOOL CALLBACK EnumResLangFunc(HMODULE hModule, LPCTSTR lpszType, LPCTSTR lpszName, WORD wIDLanguage,  LONG lParam) {
#if defined(__FILE__LOGGER__) && !defined(LOGGER_UNDEF)
   CString strName;
   if (IS_INTRESOURCE(lpszName)) {
      strName.Format(_T("%i"), lpszName);
   } else {
      strName = lpszName;
   }
   LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  Type=[%s] Name=[%s] Language=[%s] "), (LPCTSTR)CLogger::ResourceType(lpszType, FALSE), (LPCTSTR)strName, (LPCTSTR)::Locale(wIDLanguage));
   return TRUE;
#else
   ::SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
   return FALSE;
#endif
}

BOOL CALLBACK EnumResNameFunc(HMODULE hModule, LPCTSTR lpszType, LPTSTR lpszName, LONG lParam) {
   return ::EnumResourceLanguages(hModule, lpszType, lpszName, EnumResLangFunc, lParam);
}
 
BOOL CALLBACK EnumResourceFunc(HMODULE hModule, LPTSTR lpszType, LONG_PTR lParam) {
   return ::EnumResourceNames(hModule, lpszType, EnumResNameFunc, lParam);
}

BOOL PutTraceResource(IN HMODULE hModule) {
   return ::EnumResourceTypes(hModule, EnumResourceFunc, 0);
}
