////////////////////////////////////////////////////////////////////////////////
//                               FastMines project
//                                       Sergey Krivulya (KSerg, aka SeregaLBN)
// file name: "WinDefAdd.h"
// Additional window message handlers
// Copyright (C) 2002-2007 Sergey Krivulya
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////////////

/*
 * My Window Messages
 */

#define WM_NOTIFYICON              (WM_USER+1)
#define WM_MOSAIC_ADJUSTAREA       (WM_USER+2)
#define WM_MOSAIC_CLICK            (WM_USER+3) //      ,    ()   
#define WM_MOSAIC_CHANGECOUNTERS   (WM_USER+4) //        /
#define WM_MOSAIC_CHANGEGAMESTATUS (WM_USER+5) //          ( ,  ,  )
#define WM_MOSAIC_PAUSE            (WM_USER+6) //        

/****** My Message crackers ****************************************************/

/* void Cls_OnNotifyIcon(HWND hWnd, UINT notifyMsg) */
#define HANDLE_WM_NOTIFYICON(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd), (UINT)(lParam)), 0L)
#define FORWARD_WM_NOTIFYICON(hWnd, notifyMsg, fn) \
    (void)(fn)((hWnd), WM_NOTIFYICON, 0L, (LPARAM)(UINT)(notifyMsg))

/* void Cls_OnMosaicAdjustArea(HWND hWnd) */
#define HANDLE_WM_MOSAIC_ADJUSTAREA(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd)), 0L)
#define FORWARD_WM_MOSAIC_ADJUSTAREA(hWnd, fn) \
    (void)(fn)((hWnd), WM_MOSAIC_ADJUSTAREA, 0L, 0L)

/* void Cls_OnMosaicClick(HWND hWnd, BOOL leftClick, BOOL down) */
#define HANDLE_WM_MOSAIC_CLICK(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd), (BOOL)LOWORD(lParam), (BOOL)HIWORD(lParam)), 0L)
#define FORWARD_WM_MOSAIC_CLICK(hWnd, leftClick, down, fn) \
    (void)(fn)((hWnd), WM_MOSAIC_CLICK, (WPARAM)0L, MAKELPARAM((leftClick), (down)))

/* void Cls_OnMosaicChangeCounters(HWND hWnd) */
#define HANDLE_WM_MOSAIC_CHANGECOUNTERS(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd)), 0L)
#define FORWARD_WM_MOSAIC_CHANGECOUNTERS(hWnd, fn) \
    (void)(fn)((hWnd), WM_MOSAIC_CHANGECOUNTERS, 0L, 0L)

/* void Cls_OnMosaicChangeGameStatus(HWND hWnd, EGameStatus eGS) */
#define HANDLE_WM_MOSAIC_CHANGEGAMESTATUS(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd), EGameStatus(wParam)), 0L)
#define FORWARD_WM_MOSAIC_CHANGEGAMESTATUS(hWnd, status, fn) \
    (void)(fn)((hWnd), WM_MOSAIC_CHANGEGAMESTATUS, (WPARAM)status, 0L)

/* void Cls_OnMosaicPause(HWND hWnd) */
#define HANDLE_WM_MOSAIC_PAUSE(hWnd, wParam, lParam, fn) \
    ((fn)((hWnd)), 0L)
#define FORWARD_WM_MOSAIC_PAUSE(hWnd, fn) \
    (void)(fn)((hWnd), WM_MOSAIC_PAUSE, 0L, 0L)

#ifndef WM_MOUSEWHEEL
   #define WM_MOUSEWHEEL 0x020A
#endif

//   '' VC++6  HANDLE_WM_MOUSEWHEEL  FORWARD_WM_MOUSEWHEEL .
//    <WindowsX.h>,  -  Platform SDK...
//     FORWARD_WM_MOUSEWHEEL    (  8 ).
//   .
/* void Cls_OnMouseWheel(HWND hWnd, int xPos, int yPos, int zDelta, WORD fwKeys) */
#ifndef HANDLE_WM_MOUSEWHEEL
   #define HANDLE_WM_MOUSEWHEEL(hWnd, wParam, lParam, fn) \
       ((fn)((hWnd), (int)(short)LOWORD(lParam), (int)(short)HIWORD(lParam), (int)(short)HIWORD(wParam), (UINT)(short)LOWORD(wParam)), 0L)
#endif
#ifdef FORWARD_WM_MOUSEWHEEL
   #undef FORWARD_WM_MOUSEWHEEL
#endif
#define FORWARD_WM_MOUSEWHEEL(hWnd, xPos, yPos, zDelta, fwKeys, fn) \
    (void)(fn)((hWnd), WM_MOUSEWHEEL, MAKEWPARAM((fwKeys),(zDelta)), MAKELPARAM((xPos), (yPos)))
